.intel_syntax noprefix

.data

niz: .float 1.0, 1.0, 1.0, 1.0 
fact: .float 1.0, 2.0, 6.0, 24.0
fact_pom: .float 2.0, 3.0, 4.0, 5.0

.text

# Funkcija expMac racuna vrednost e^x u datoj tacki x koristeci Maklorenov polinom stepena n
# float expMac(float x, int n)
# xmm0         xmm0     rdi

.global expMac

expMac:
    enter 0, 0

    movups xmm1, niz # xmm1 = 1.0 1.0 1.0 1.0
    movups xmm2, fact # xmm2 = 1.0 2.0 6.0 24.0
    movups xmm3, fact_pom # xmm3 = 2.0 3.0 4.0 5.0 
    movups xmm4, niz # xmm4 = 1.0 1.0 1.0 1.0
    xorps xmm5, xmm5 # xmm5 = 0 0 0 0
    addss xmm5, xmm1 # xmm5 = 0 0 0 1
    shufps xmm0, xmm0, 0b00000000 # xmm0 = x x x x
    mulps xmm1, xmm0 # xmm1 = x x x x
    mulps xmm1, xmm1 # xmm1 = x2 x2 x2 x2
    mulps xmm1, xmm1 # xmm1 = x4 x4 x4 x4

    movss xmm7, xmm0 # xmm7 = _ _ _ x
    mulss xmm0, xmm7 # xmm0 = x x x x^2
    mulss xmm0, xmm0 # xmm0 = x x x x^4
    shufps xmm0, xmm0, 0b00100111
    mulss xmm0, xmm7 # xmm0 = x^4 x x x^2
    mulss xmm0, xmm7 # xmm0 = x^4 x x x^3
    shufps xmm0, xmm0, 0b11000110
    mulss xmm0, xmm7 # xmm0 = x^4 x^3 x x^2
    shufps xmm0, xmm0, 0b11100001 # xmm0 = x^4 x^3 x^2 x^1

petlja:
    cmp rdi, 0
    je kraj_petlja
    movups xmm6, xmm0 # xmm6 = x4 x3 x2 x (komentari su samo za prvu iteraciju)
    divps xmm6, xmm2 # xmm6 = x4/24 x3/6 x2/2 x/1
    addps xmm5, xmm6 # xmm5 += xmm6
    
    mulps xmm2, xmm3 # xmm2 = 2 6 24 120
    addps xmm3, xmm4 # xmm3 = 3 4 5 6
    mulps xmm2, xmm3 # xmm2 = 6 24 120 720
    addps xmm3, xmm4 # xmm3 = 4 5 6 7
    mulps xmm2, xmm3 # xmm2 = 24 120 720 5040
    addps xmm3, xmm4 # xmm3 = 5 6 7 8
    mulps xmm2, xmm3 # xmm2 = 120 720 5040 40320
    addps xmm3, xmm4 # xmm3 = 6 7 8 9

    mulps xmm0, xmm1 # xmm0 = x8 x7 x6 x5
    sub rdi, 4
    jmp petlja


kraj_petlja:
    movhlps xmm6, xmm5 # xmm5 = a3 a2 a1 a0, xmm6 = _ _ a3 a2
    addps xmm5, xmm6 # xmm5 = _ _ a3+a1 a2+a0
    movups xmm6, xmm5 # xmm 6 = _ _ a3+a1 a2+a0
    shufps xmm6, xmm6, 0b01010101 # xmm5 = a3+a1 a3+a1 a3+a1 a3+a1
    addss xmm5, xmm6 # xmm5 = _ _ _ a3+a2+a1+a0
    movss xmm0, xmm5 # xmm0 = _ _ _ a3+a2+a1+a0

kraj:
    leave
    ret
